package;

import flash.ui.Mouse;
import org.flixel.FlxButton;
import org.flixel.FlxG;
import org.flixel.FlxGroup;
import org.flixel.FlxPoint;
import org.flixel.FlxSprite;
import org.flixel.FlxState;
import org.flixel.FlxText;
import org.flixel.FlxBasic;
import org.flixel.FlxTilemap;
import org.flixel.FlxObject;
import org.flixel.FlxSave;
import org.flixel.FlxSound;
import nme.Assets;
import nme.media.Sound;
import nme.media.SoundTransform;

import com.eclecticdesignstudio.motion.Actuate;
import com.eclecticdesignstudio.motion.easing.Elastic;
import com.eclecticdesignstudio.motion.easing.Quad;



class MenuLevel extends BaseLevel
{

	public var titleOut:FlxSprite;
	public var titleF:FlxSprite;
	public var startXR:FlxText;
	public var hotText:FlxText;
	public var mildText:FlxText;
	public var instructo:FlxText;
	public var keyBoarded:Bool;
	public var hotInfo:Bool;
	public var mildInfo:Bool;

	public var mildLabel:FlxText;
	public var mildLabel2:FlxText;
	public var hotLabel:FlxText;
	public var taco1:FlxSprite;
	public var taco2:FlxSprite;
	public var spot1:FlxSprite;
	public var spot2:FlxSprite;
	public var mildStartLevel:Int;
	public var titleSound:FlxSound;
	private var movingOn:Bool;
	private var arrowsFaded:Bool;
	




	public function new()
	{
		
		super();

	}
	
	
	override public function create():Void
	{

		movingOn = false;	
		arrowsFaded = false;	
		// SOUND STUFF
		titleSound =  FlxG.loadSound(Assets.getSound("assets/sounds/robotWantsTacoFast2.mp3"),.80);
        titleSound.play ();
        if(FlxAssets.robotTheme==null){
			FlxAssets.robotTheme = FlxG.loadSound(Assets.getSound ("assets/sounds/RobotThemeNoIntro2.mp3"),0,true);
	        FlxAssets.robotTheme.survive = true;
	        FlxAssets.robotTheme.play();
	       	Actuate.update (updateThemeVol, 9, [0],[.5]).delay(0);
       }
       
       	//Actuate.tween(FlxAssets.robotTheme,1.0,{volume:.1});
       	//FlxAssets.robotTheme.volume = .1;
       // FlxG.playMusic(Assets.getSound ("assets/sounds/RobotTheme.wav"),.55);


       	FlxAssets.wordArray = new Array<Dynamic>();
		FlxAssets.wordArray[0] = "TACO";
		FlxAssets.wordArray[1] = "FIESTA";
		FlxAssets.wordArray[2] = "RADICAL";
		FlxAssets.wordArray[3] = "GREAT";
		FlxAssets.wordArray[4] = "GNARLY";
		FlxAssets.wordArray[5] = "SUPER";
		FlxAssets.wordArray[6] = "YES";
		FlxAssets.wordArray[7] = "YUMMY";
		FlxAssets.wordArray[8] = "TASTY";
		FlxAssets.wordArray[9] = "WICKED";
		//FlxAssets.wordArray[10] = "FANTASTIC";

		FlxAssets.tacoSoundArray = new Array<Dynamic>();

		for (i in 0...FlxAssets.wordArray.length) {
			var tempS:Sound = Assets.getSound("assets/sounds/"+FlxAssets.wordArray[i]+".mp3");
			FlxAssets.tacoSoundArray[i] = tempS;
		}


			
			

		//saveGame Stuff
		FlxAssets.saveGame = new FlxSave();
		FlxAssets.level = 0;
		mildStartLevel=0;
		FlxAssets.totalTacos = 0;
		if(FlxAssets.saveGame.bind("RobotWants")){
			if(FlxAssets.saveGame.data.hotLevel==null){
				FlxAssets.hotHighScore = 0;
			}
			else{
				FlxAssets.hotHighScore = FlxAssets.saveGame.data.hotLevel;

			}
			if(FlxAssets.saveGame.data.mildScore==null){
				FlxAssets.mildHighScore = 0;
			}
			else{
				FlxAssets.mildHighScore = FlxAssets.saveGame.data.mildScore;
				//FlxAssets.totalTacos = FlxAssets.saveGame.data.mildScore;
			}

			if(FlxAssets.saveGame.data.mildHighLevel==null){
				FlxAssets.mildHighLevel = 0;
			}
			else{
				FlxAssets.mildHighLevel = FlxAssets.saveGame.data.mildHighLevel;
				//FlxAssets.totalTacos = FlxAssets.saveGame.data.mildScore;
			}

			

			if(FlxAssets.saveGame.data.currentGameScore==null){
				FlxAssets.totalTacos = 0;
			}
			else{

				FlxAssets.totalTacos = FlxAssets.saveGame.data.currentGameScore;
			}

			if(FlxAssets.saveGame.data.ourLevel==null){
				FlxAssets.saveGame.data.ourLevel=0;
			}
			else{
				mildStartLevel = FlxAssets.saveGame.data.ourLevel;
			}

		}
		//end of sound good stuff

		//Initialize Stuff
		var t:FlxText;
		//t = new FlxText(0, FlxG.height / 2 - 20, FlxG.width, "Tilemap Demo");
		t = new FlxText(0, FlxG.height / 2 - 20, FlxG.width, "ROBOT WANTS TACO");
		t.setFont("assets/bithigh");
		t.size = 48;
		t.alignment = "center";
		//add(t);
		t = new FlxText(FlxG.width / 2 - 100, FlxG.height - 30, 200, "CLICK TO TEST");
		t.setFont("assets/bithigh");
		t.size = 24;
		t.alignment = "center";
		//add(t);

		FlxAssets.hasForce = false;
		FlxAssets.hasSuperShot = false;
		FlxAssets.hasTriple = false;
		//FlxG.framerate = 303
		//FlxG.flashFramerate =30 ;

		//setup the total number of tacos + initial Tacos
		
		FlxAssets.tacoNum=3;

		/// end of initialize

		
		backGround = new FlxSprite(0,0);
		backGround.alpha = .55;
		backGround.loadGraphic(FlxAssets.menuBg,false,false,800,600);
		add(backGround);

		map = new FlxTilemap();
		map.loadMap(Assets.getText("assets/mapCSV_Group1_Level0.csv"),FlxAssets.tileImg2,20,20,FlxTilemap.OFF);
		add(map);

		spot1 = new FlxSprite(113,0,FlxAssets.spotImg);
		add(spot1);

		spot2 = new FlxSprite(633,0,FlxAssets.spotImg);
		spot2.alpha= 0;
		add(spot2);

		spot1.alpha = 0;
		taco1 = new FlxSprite(129,518,FlxAssets.tacoImg);
		add(taco1);

		taco2 = new FlxSprite(649,518,FlxAssets.tacoImg);
		add(taco2);
		super.create();
			
		//overlay
		overlayGroup = new FlxGroup();

		overlay = new FlxSprite(0,0);
		overlay.makeGraphic(FlxG.width,FlxG.height,0xff000000);
		overlay.alpha=0;
		add(overlay);

		levelInfo = new FlxText(0,FlxG.height*.45,FlxG.width);
		levelInfo.setFont("assets/bithigh");
		levelInfo.setFormat(32,0xffffffff,"center",0xff363636);
		levelInfo.text="LEVEL " + FlxAssets.level;
		levelInfo.alpha=0;
		add(levelInfo);
		

		//titles
		titleOut = new FlxSprite(280,-200,FlxAssets.titleOutline);
		titleF = new FlxSprite(280,-200,FlxAssets.titleFill);
		add(titleF);
		add(titleOut);

		Actuate.tween(titleF,2.2,{y:44}).ease (Elastic.easeOut).onComplete(moveFill);
		Actuate.tween(titleOut,2.45,{y:46}).ease (Elastic.easeOut);


		//Actuate.tween(titleF,1.5,{y:50}).ease (Elastic.easeOut);
		//instructions

		instructo = new FlxText(FlxG.width / 2 - 150, FlxG.height - 30, 300, "USE THE ARROW KEYS TO MOVE");
		instructo.setFont("assets/bithigh");
		//instructo.shadow = 0xff6f4f4f;
		instructo.size = 14;
		instructo.alignment = "center";
		add(instructo);

		ourPlayer.x=395;
		ourPlayer.y=540;
		ourPlayer.stillTime=4;


		//t = new FlxText(0, FlxG.height / 2 - 20, FlxG.width, "Tilemap Demo");
		hotLabel = new FlxText(101,478,80, "HOT");
		hotLabel.setFont("assets/bithigh");
		//hotLabel.shadow = 0xff333333;
		hotLabel.size = 18;
		hotLabel.alpha=1;
		hotLabel.alignment = "center";
		add(hotLabel);

		mildLabel = new FlxText(621,478,80, "MILD");
		mildLabel.setFont("assets/bithigh");
		mildLabel.size = 18;
		mildLabel.alpha=1;
		mildLabel.alignment = "center";
		add(mildLabel);


		mildLabel2 = new FlxText(621,500,80, "PRESS X TO RESET");
		mildLabel2.setFont("assets/bithigh");
		mildLabel2.size = 10;
		mildLabel2.alpha=0;
		//mildLabel2.color= 0xff6f4f4f;
		mildLabel2.alignment = "center";
		//mildLabel2.visible=false;
		add(mildLabel2);


		//startXR
		//t = new FlxText(0, FlxG.height / 2 - 20, FlxG.width, "Tilemap Demo");
		startXR = new FlxText(100,546,80, "HIGHEST LEVEL");
		startXR.setFont("assets/bithigh");
		startXR.size = 13;
		startXR.alpha=0;
		startXR.color= 0xff6f4f4f;
		startXR.alignment = "center";
		add(startXR);




		hotText = new FlxText(102,546,80, "ONE LIFE TO LIVE");
		hotText.setFont("assets/bithigh");
		hotText.size = 12;
		hotText.alpha=.7;
		//hotText.color = 0xff432c2c;
		hotText.alignment = "center";
		//add(hotText);
		hotText.visible = true;	


		mildText = new FlxText(622,546,80, "LIFE EVERLASTING");
		mildText.setFont("assets/bithigh");
		mildText.size = 12  ;
		mildText.alpha=.7;
		//mildText.color = 0xff432c2c;
		mildText.alignment = "center";
		//add(mildText);
		mildText.visible = true;		


		taco.visible = false;
		keyBoarded = false;
		hotInfo = false;
		mildInfo = false;










		
	}

	public function moveFill(){
		if(!movingOn){
			Actuate.tween(titleOut,.55,{y:FlxG.randomRange(48,40),x:FlxG.randomRange(284,276)}).ease (Elastic.easeOut).onComplete(moveFill).delay(.5);
			Actuate.tween(titleF,.55,{y:FlxG.randomRange(50,42),x:FlxG.randomRange(281,279)}).ease (Elastic.easeOut).onComplete(moveFill).delay(.5);

			Actuate.update (titleOut.setAlpha, .2525, [1],[0]).repeat().reflect();
		}
		//Actuate.tween(titleOut,1,{alpha:.5});
	}

	public function updateThemeVol(vol:Float){
		FlxAssets.robotTheme.volume = vol;
	}


	override public function nextLevel():Void{
		if (FlxAssets.gameMode==1) {
			mildStartLevel++;
			FlxAssets.level=mildStartLevel;
			FlxG.switchState(Type.createInstance(Type.resolveClass("Level"+mildStartLevel),[]));
			//FlxG.switchState(new Level16());
		}
		else{
			FlxG.switchState(new Level1());
		}
	}
	
	override public function levelComplete():Void{
		taco1.kill();
		taco2.kill();
		movingOn=true;
		dingSound.play();

		Actuate.update (mildLabel.setAlpha, 1, [1],[0]);
		Actuate.update (hotLabel.setAlpha, 1, [1],[0]);
		Actuate.update (instructo.setAlpha, 1, [1],[0]);
		Actuate.update (startXR.setAlpha, 1, [1],[0]);
		Actuate.update (mildLabel2.setAlpha, 1, [mildLabel2.alpha],[0]);

		//ourPlayer.kill();


		//stars.alpha = 1;
		//stars.scale.y=1.5;
		//stars.scale.x=1.5;
		//stars.x = ourPlayer.x-6;
		//stars.y = ourPlayer.y - 6;
		//Actuate.tween(stars.scale,1,{x:0,y:0},false).delay(.125);
		//Actuate.update (stars.setAlpha, 1, [1],[0]);




		Actuate.update (overlay.setAlpha, 1, [0],[1])
		.ease (Elastic.easeOut)
		.delay(.75)
		.onComplete(nextLevel);

		Actuate.tween (titleOut,1,{y:-500});

		Actuate.tween (titleF,1,{y:-500});

		//levelInfo.size=64;		

		//scoreStar = new FlxSprite(387.5,levelInfo.y+72);
		FlxAssets.tacoNum=3;
		FlxAssets.level++;
	}


	

	
	override public function update():Void
	{
		super.update();

		if (ourPlayer.x>100&&ourPlayer.x<380&&arrowsFaded) {
			spot1.setAlpha((380-ourPlayer.x) * .0045 );
			if (FlxG.overlap(ourPlayer,taco1)) {
				FlxAssets.gameMode=2;
				FlxAssets.hotLives = 3;
				levelComplete();
			}
			if (!hotInfo) {
				startXR.x = 102;
				if (FlxAssets.hotHighScore>0) {
					startXR.text = "HIGH LEVEL\n"+ Std.string(FlxAssets.hotHighScore);
				}
				else{
					startXR.text = "HIGH LEVEL\n";
				}
				
				hotInfo=true;
				instructo.text = "CHALLENGE MODE WITH ONLY THREE LIVES";
				Actuate.update (instructo.setAlpha, .5, [0],[1]);
				//Actuate.tween(hotLabel,.5,{y:hotLabel.y-20});
				//Actuate.tween(taco1,.5,{y:taco1.y-20});
				Actuate.update (startXR.setAlpha, .5, [0],[1]);
			}
		}
		else{
			if (keyBoarded&&hotInfo&&arrowsFaded) {
				Actuate.update (instructo.setAlpha, .5, [1],[0]);
				//Actuate.tween(hotLabel,.5,{y:hotLabel.y+20});
				//Actuate.tween(taco1,.5,{y:taco1.y+20});
				Actuate.update (startXR.setAlpha, .5, [1],[0]);
				hotInfo=false;
			}
		}

		if (ourPlayer.x>420&&ourPlayer.x<700&&arrowsFaded) {
			spot2.setAlpha((ourPlayer.x-420) * .0045);
			if(FlxG.keys.justPressed("X")){
				if(FlxAssets.saveGame.bind("RobotWants")){
					FlxAssets.saveGame.data.ourLevel=0;
					FlxAssets.saveGame.data.currentGameScore = 0;
					FlxAssets.mildHighScore=0;
					mildStartLevel = 0;
					taco1.kill();
					taco2.kill();
					titleOut.kill();
					titleF.kill();
			
					Actuate.update (mildLabel.setAlpha, .25, [1],[0]);
					Actuate.update (hotLabel.setAlpha, .25, [1],[0]);
					Actuate.update (instructo.setAlpha, .25, [1],[0]);
					Actuate.update (mildLabel2.setAlpha, 1, [mildLabel2.alpha],[0]);
					Actuate.update (startXR.setAlpha, .25, [1],[0]);
					Actuate.update (overlay.setAlpha, .25, [0],[1])
					.ease (Elastic.easeOut)
					.onComplete(backHome);
				}
			}
			if (FlxG.overlap(ourPlayer,taco2)) {
				FlxAssets.gameMode=1;
				levelComplete();
			}
			if (!mildInfo) {
				startXR.x = 622;

				if (FlxAssets.mildHighScore>0) {
					startXR.text = "HIGH SCORE\n"+Std.string(FlxAssets.mildHighScore)+"/"+Std.string((FlxAssets.mildHighLevel)*3);
					Actuate.update (mildLabel2.setAlpha, .5, [0],[1]);
				}
				else{
					startXR.text = "HIGH SCORE\n";
				}
				mildInfo=true;
				instructo.text = "CASUAL MODE WITH EVERLASING LIFE";
				Actuate.update (instructo.setAlpha, .5, [0],[1]);
				Actuate.update (startXR.setAlpha, .5, [0],[1]);
			}
		}
		else{
			if (keyBoarded&&mildInfo&&arrowsFaded) {
				Actuate.update (instructo.setAlpha, .5, [1],[0]);
				Actuate.update (startXR.setAlpha, .5, [1],[0]);
				Actuate.update (mildLabel2.setAlpha, 1, [mildLabel2.alpha],[0]);
				//Actuate.update (mildLabel2.setAlpha, .5, [1],[0]);
				mildInfo=false;
			}


		}

		if (!keyBoarded){
			if(FlxG.keys.pressed("LEFT")||FlxG.keys.pressed("RIGHT")||FlxG.keys.pressed("UP")||FlxG.keys.pressed("DOWN")){
				//Actuate.update (instructo.setAlpha, .5, [0],[1]);
				Actuate.update (instructo.setAlpha, .5, [1],[0]).onComplete(keyTrue);
				keyBoarded=true;
			}
		}

		FlxG.collide(lazerGroup,enemyGroup,enemyHit);
		FlxG.collide(lazerGroup,map,mapZap);
		updateParts();


	}//end of update

	public function keyTrue(){
		arrowsFaded=true;
	}

}